/////////////////////////////////////////////////////////////////////////////
// Name:        statline.cpp
// Purpose:
// Author:      Robert Roebling
// Id:          $Id: statline.cpp,v 1.3 1999/06/14 23:04:03 RR Exp $
// Copyright:   (c) 1998 Robert Roebling
// Licence:           wxWindows licence
/////////////////////////////////////////////////////////////////////////////

#ifdef __GNUG__
#pragma implementation "statline.h"
#endif

#include "wx/statline.h"

#if wxUSE_STATLINE

#include "gdk/gdk.h"
#include "gtk/gtk.h"

//-----------------------------------------------------------------------------
// wxStaticLine
//-----------------------------------------------------------------------------

IMPLEMENT_DYNAMIC_CLASS(wxStaticLine,wxControl)

wxStaticLine::wxStaticLine(void)
{
}

wxStaticLine::wxStaticLine( wxWindow *parent, wxWindowID id,
      const wxPoint &pos, const wxSize &size, 
      long style, const wxString &name )
{
    Create( parent, id, pos, size, style, name );
}

bool wxStaticLine::Create( wxWindow *parent, wxWindowID id, 
      const wxPoint &pos, const wxSize &size, 
      long style, const wxString &name )
{
    m_needParent = TRUE;
  
    PreCreation( parent, id, pos, size, style, name );

    if (style & wxVERTICAL)
        m_widget = gtk_vseparator_new();
    else
        m_widget = gtk_hseparator_new();
  
    m_parent->DoAddChild( this );
  
    PostCreation();
  
    Show( TRUE );
    
    return TRUE;
}

#endif